gocek/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('helloworld.urls')),
    path('hiburan/', include('hiburan.urls')),
    path('pasar/', include('pasar_zaldy.urls')),
    path('rumah-sakit/', include('rumah_sakit.urls')),
    path('restoran/', include('restoran.urls')),
    path('account/', include('sistemlogin.urls')),
]

hiburan/urls.py
from django.urls import path
from . import views


app_name = 'hiburan'

urlpatterns = [
    path('', views.index, name='index'),
    path('addTempat/', views.addTempat, name='addTempat'),
    path('<int:id>/addFoto/', views.addFoto, name='addFoto'),
    path('detail/<int:id>/', views.detail, name='detail'),
    path('<int:id>/update/', views.update, name='update'),

]

hiburan/models.py
from django.db import models
from django.core.validators import RegexValidator


class Hiburan(models.Model):

    nama = models.CharField(max_length=50)
    status = models.CharField(max_length=50)
    budget = models.CharField(max_length=15)
    kontak = models.CharField(max_length=15, default='080000000000')
    alamat = models.TextField()
    jam_buka = models.CharField(max_length=50,null = True)
    jam_tutup = models.CharField(max_length=50,null = True)
    foto = models.CharField(max_length=50, null = True)

    def __str__(self):
        return self.nama

class Fotos(models.Model):
    link_foto = models.CharField(max_length=100)
    tempat_hiburan = models.ForeignKey(Hiburan, null=True, on_delete= models.CASCADE)
    
    def __str__(self):
        return self.link_foto

hiburan/forms.py
from django.forms import Form
from django import forms
from .models import *

class CreateHiburan(forms.Form):
    update = False
    nama = forms.CharField(widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'placeholder' : 'Nama tempat?',
        'type' : 'text',
        'required' : True,
        'disable' : update,
    }))
    status = forms.CharField(widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'placeholder' : 'Sesuai Protokol Covid?',
        'type' : 'text',
        'required' : True,
    }))
    budget = forms.CharField(widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'placeholder' : 'Berapa budgetnya',
        'type' : 'text',
        'required' : True,
    }))
    kontak = forms.CharField(widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'placeholder' : 'Nomor kontaknya?',
        'type' : 'text',
        'required' : True,
    }))
    alamat = forms.CharField(widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'placeholder' : 'Dimana tempatnya?',
        'type' : 'text',
        'required' : True,
        'disable' : update,
    }))
    
    jam_buka = forms.CharField(widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'placeholder' : 'Pukul Buka?',
        'type' : 'text',
        'required' : True,
    }))
    
    jam_tutup = forms.CharField(widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'placeholder' : 'Pukul Tutup?',
        'type' : 'text',
        'required' : True,
    }))

    foto = forms.CharField(widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'placeholder' : 'Linknya Boleh Di-Upload Disini',
        'type' : 'text',
        'required' : True,
    }))

    class Meta:
        model = Hiburan
        fields = ['nama','status','budget','kontak','alamat','foto','jam_buka','jam_tutup',]
    # foto = forms.ImageField()
    # jam_buka = forms.TimeField(widget=forms.TimeInput)
    # jam_tutup = forms.TimeField(widget=forms.TimeInput)

class CreateFoto(forms.Form):
    link_foto = forms.CharField(widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'placeholder' : 'Linknya Dong',
        'type' : 'text',
        'required' : True,
    }))
    class Meta:
        model = Fotos
        fields = ['link_foto']

hiburan/views.py
from django.shortcuts import render, get_object_or_404, render,  redirect
from .forms import CreateHiburan, CreateFoto
from .models import Hiburan, Fotos
from . import models, forms


# Create your views here.

def index(request):
    # hiburan = Hiburan.objects.all()
    
    print(Hiburan.objects.all())
    return render(request, 'hiburan/index.html', {"hiburan" : Hiburan.objects.all()})

def addTempat(request):
    form = CreateHiburan()
    if request.method == 'POST':
        form = forms.CreateHiburan(request.POST)
        if form.is_valid():
            hbrn = models.Hiburan()
            hbrn.nama = form.cleaned_data['nama']
            hbrn.status = form.cleaned_data['status']
            hbrn.budget = form.cleaned_data['budget']
            hbrn.kontak = form.cleaned_data['kontak']
            hbrn.alamat = form.cleaned_data['alamat']
            hbrn.jam_buka = form.cleaned_data['jam_buka']
            hbrn.jam_tutup = form.cleaned_data['jam_tutup']
            hbrn.foto = form.cleaned_data['foto']
            hbrn.save()
            return redirect('/hiburan')
    return render(request, 'hiburan/addTempat.html', {'form':form})

def addFoto(request, id):
    if request.method == "POST":
        form = CreateFoto(request.POST)
        if form.is_valid():
            fotonya = Fotos(tempat_hiburan=Hiburan.objects.get(pk=id))
            fotonya.link_foto = form.data['link_foto']
            fotonya.save()  
        return redirect('/hiburan/detail/'+str(id))
    form = CreateFoto()
    return render(request, "hiburan/addFoto.html", {'data': form})


def detail(request, id):
    obj = get_object_or_404(Hiburan, id=id)
    fotos = Fotos.objects.filter(tempat_hiburan=obj)
    return render(request, 'hiburan/detail.html', {"obj":obj, "fotos":fotos})

def update(request, id):
    hbrn = Hiburan.objects.get(pk=id)
    form = CreateHiburan()
    if request.method == 'POST':
        data = request.POST
        hbrn.status = data['status']
        hbrn.budget = data['budget']
        hbrn.kontak = data['kontak']
        hbrn.alamat = data['alamat']
        hbrn.save()
        return redirect('/hiburan/detail/'+str(id))
    context = {
        'form' : form
    }
    return render(request, "hiburan/update.html", context)

templates/hiburan/addFoto.html
{% extends 'base.html' %}
{% load static %}
{% block meta %}
    <title>Tambah Foto Untuk Tempat Hiburan</title>
    <link rel="stylesheet" type="text/css" href="{% static 'css/addFoto.css' %}">
{% endblock %}
{% block headercontent %}
    <span>Tambah <br> Foto Untuk <br> Tempat Hiburan</span>
{% endblock %}
{% block content %}
<div class="container" style="margin: auto;">
    <div class="row justify-content-center">
        <div class="card-body "
            style="border: none; border-radius: 20px; border-color: #2c063c; background-color:#F2F2F2; ">

            <p class="card-text">
                <br>
                <form method="POST" style="margin: 10px;">
                    <div class="form-group">
                        {% csrf_token %}
                        <div class="form-group row">
                            <label for="inputPassword3" class="col-sm-2 form-control-label"> <h5>Link Foto:</h5></label>
                            <div class="col-sm-10" >
                                {{ data.link_foto }}
                            </div>
                        </div>
                        <input type="submit" class="btn btn-primary btn-lg" value="Tambah" />
                    </div>
                </form>
            </p>
        </div>
    </div>
</div>
</div>


{% endblock %}

templates/hiburan/addTempat.html
{% extends 'base.html' %}
{% load static %}
{% block meta %}
    <title>Tambah Tempat Hiburan</title>
    <link rel="stylesheet" type="text/css" href="{% static 'css/addTempat.css' %}">
{% endblock %}
{% block headercontent %}
    <span>Tambah <br> Tempat Hiburan</span>
{% endblock %}
{% block content %}
<div class="container" style="margin: auto;">
    <div class="row justify-content-center">
        <div class="card-body mt-5"
             style="border: none; border-radius: 20px; border-color: #2c063c; background-color:#F2F2F2; ">
            <p class="card-text">
            <form method="POST" style="margin: 10px;" enctype="multipart/form-data">
                {% csrf_token %}
                <div class="form">
                    <div class="form-group row">
                        <label for="inputPassword3" class="col-sm-2 form-control-label">
                            <h5>Nama Tempat:</h5>
                        </label>
                        <div class="col-sm-10">
                            {{ form.nama }}
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputPassword3" class="col-sm-2 form-control-label">
                            <h5>Status:</h5>
                        </label>
                        <div class="col-sm-10">
                            {{ form.status }}
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputPassword3" class="col-sm-2 form-control-label">
                            <h5>Budget:</h5>
                        </label>
                        <div class="col-sm-10">
                            {{ form.budget }}
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputPassword3" class="col-sm-2 form-control-label">
                            <h5>Kontak:</h5>
                        </label>
                        <div class="col-sm-10">
                            {{ form.kontak }}
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputPassword3" class="col-sm-2 form-control-label">
                            <h5>Alamat:</h5>
                        </label>
                        <div class="col-sm-10">
                            {{ form.alamat }}
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputPassword3" class="col-sm-2 form-control-label">
                            <h5>Jam Buka:</h5>
                        </label>
                        <div class="col-sm-10">
                            {{ form.jam_buka }}
                        </div>
                    </div>
                    <div class="form-group row" >
                        <label for="inputPassword3" class="col-sm-2 form-control-label">
                            <h5>Jam Tutup:</h5>
                        </label>
                        <div class="col-sm-10">
                            {{ form.jam_tutup }}
                        </div>
                    </div>
                    <div class="form-group row" >
                        <label for="inputPassword3" class="col-sm-2 form-control-label">
                            <h5>Link Foto:</h5>
                        </label>
                        <div class="col-sm-10">
                            {{ form.foto }}
                        </div>
                    </div>
                    <div class="button d-flex justify-content-center">
                        <input type="submit" value="Simpan" class="btn btn-block" style="border-radius: 25px; 
                        font-size: 25px; color: white; background-color:#4180E2;
                        width: 10em; margin-bottom: 30px ;margin-top: 30px; font-weight: bold;"
                        role="button"/>
                        <a class="btn btn-danger btn-block ml-2" style="border-radius: 25px; 
                        font-size: 25px; color: white; background-color:#E24141;
                        width: 10em; margin-bottom: 30px ;margin-top: 30px;" href="{% url 'hiburan:index'%}" 
                        role="button"><strong>Batal</strong></a>
                    </div>
                </div>
            </form>
            </p>
        </div>
    </div>
</div>

{% endblock %}

templates/hiburan/detail.html
{% extends 'base.html' %}
{% load static %}
{% block meta %}
    <title>Detail Tempat Hiburan</title>
    <link rel="stylesheet" type="text/css" href="{% static 'css/addTempat.css' %}">
{% endblock %}
{% block headercontent %}
    <span>Detail <br>{{obj.nama}}</span>
{% endblock %}
{% block content %}
<div class="container container-fluid" style="margin: 0 auto;">
    <div> <a class="btn btn-primary btn-block ml-auto" style="font-size: large; color: white; 
    width: 12rem; margin-bottom: 30px ;margin-top: 30px;" href="{% url 'hiburan:update' obj.id %}"
            role="button">Update</a></div>
    <div class="card p-0" data-aos="fade-up" data-aos-offset="10" style="border: none;">
        <div class="row">
            <div class="col-xl-5 px-0">
                <img class="img-fluid gambar" style=" border-radius: 15px;" src=" {{obj.foto}}"
                    alt="Card image cap">
            </div>
            <div class="col-xl">
                <div class="row">
                    <br><br><br><br>
                    <div class="selection style=" background-color: #5DCAE8;>
                        <div class="container">
                            <div class=" card border-0" style="width: 25rem; height: 25rem">
                                <div class="card-body">
                                    <div class="infodetail lh-0">
                                        <strong>Alamat:</strong>
                                        <div class="card-title">{{obj.alamat}} </div>
                                    </div>
                                    <div class="infodetail lh-0">
                                        <strong>Jam Operasional:</strong>
                                        <div class="card-title">{{obj.jam_buka}} - {{obj.jam_tutup}}</div>
                                    </div>
                                    <div class="infodetail lh-0">
                                        <strong>Status Covid:</strong>
                                        <div class="card-title">{{obj.status}}</div>
                                    </div>
                                    <div class="infodetail lh-0">
                                        <strong>Budget:</strong>
                                        <div class="card-title">{{obj.budget}}</div>
                                    </div>
                                    <div class="infodetail lh-0">
                                        <strong>Kontak:</strong>
                                        <div class="card-title">{{obj.kontak}}</div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

            </div>
        </div>
    </div>
</div>
<div class="selection">
    <div class="container">
        <div> <a class="btn btn-primary btn-block ml-auto" style="font-size: large; color: white; 
        width: 12rem; margin-bottom: 30px ;margin-top: 30px;"
                href="{% url 'hiburan:addFoto' id=obj.id %}" role="button">+ Tambah Foto</a></div>
        <table class="table table-hover text-center ">
            <thead style="background-color: #ADC9F5;">
                <tr>
                    <th scope="col">Link</th>
                </tr>
            </thead>
            <tbody>
                {% for i in  fotos %}
                <tr>
                     <th scope="row"><img class="img-fluid gambar" style=" border-radius: 15px;" src=" {{i.link_foto}}" alt="Card image cap"></th>
                </tr>
                {% endfor %}
            </tbody>
        </table>
    </div>
</div>


{% endblock %}

templates/hiburan/index.html
{% extends 'base.html' %}
{% block meta %}
    {% load static %}
    <title>Cek Tempat Hiburan</title>
{% endblock %}
{% block headercontent %}
    <span>Tempat Hiburan</span>
{% endblock %}
{% block content %}
<div>
    <div style="
               position: absolute; 
               top: 350px;
               right: 100px;
                "><a class="btn btn-primary btn-block ml-auto" style="font-size: 20px; color: white;
        width: fit-content; margin-bottom: 30px ;margin-top: 30px;" href="{% url 'hiburan:addTempat'%}" 
        role="button"><strong>+ Tambah Tempat</strong></a></div>

    <div class="d-flex justify-content-center align-content-around flex-wrap" style="margin-top: 150px;">
        {% for i in hiburan %}
        <div class="card ml-3" style="width: 18rem;">
            <img class="card-img-top" src=" {{ i.foto }}" alt="Card image cap">
            <div class="card-body">
                <h5 class="card-title">{{i.nama}}</h5>
                <div class="card-body">
                    <h6>
                        <strong>Alamat:</strong>
                    </h6>
                    <div class="card-title">{{i.alamat}}</div>
        
                    <h6>
                        <strong>Jam Operasional:</strong>
                    </h6>
                    <div class="card-title">{{i.jam_buka}} - {{i.jam_tutup}}</div>
        
                    <h6>
                        <strong>Status Covid:</strong>
                    </h6>
                    <div class="card-title">{{i.status}}</div>
        
                    <div class="text-center"><a id="detail" href="{% url 'hiburan:detail' i.id %}"
                            class="btn btn-primary" style="border-radius: 20px; width: 8rem;">Lihat Detail</a></div>
                </div>
                <div>
                </div>
            </div>
        </div>
        
        {% endfor %}
        
    </div>
</div>
{% endblock %}

templates/hiburan/update.html
{% extends 'base.html' %}
{% load static %}
{% block meta %}
    <title>Update Tempat Hiburan</title>
    <link rel="stylesheet" type="text/css" href="{% static 'css/addTempat.css' %}">
{% endblock %}
{% block headercontent %}
    <span>Update <br> Tempat Hiburan</span>
{% endblock %}
{% block content %}
<div class="container" style="margin: auto;">

    <div class="row justify-content-center">
        <div class="card-body "
            style="border: none; border-radius: 20px; border-color: #2c063c; background-color:#F2F2F2; ">

            <p class="card-text">
                <br>
            <form method="POST" style="margin: 10px;">
                <div class="form-group">
                    {% csrf_token %}
                    <div class="form-group row">
                        <label for="inputPassword3" class="col-sm-2 form-control-label">
                            <h5>Nama Tempat:</h5>
                        </label>
                        <div class="col-sm-10">
                            {{ form.nama }}
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputPassword3" class="col-sm-2 form-control-label">
                            <h5>Status:</h5>
                        </label>
                        <div class="col-sm-10">
                            {{ form.status }}
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputPassword3" class="col-sm-2 form-control-label">
                            <h5>Budget:</h5>
                        </label>
                        <div class="col-sm-10">
                            {{ form.budget }}
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputPassword3" class="col-sm-2 form-control-label">
                            <h5>Kontak:</h5>
                        </label>
                        <div class="col-sm-10">
                            {{ form.kontak }}
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputPassword3" class="col-sm-2 form-control-label">
                            <h5>Alamat:</h5>
                        </label>
                        <div class="col-sm-10">
                            {{ form.alamat }}
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="inputPassword3" class="col-sm-2 form-control-label">
                            <h5>Jam Buka:</h5>
                        </label>
                        <div class="col-sm-10">
                            {{ form.jam_buka }}
                        </div>
                    </div>
                    <div class="form-group row" >
                        <label for="inputPassword3" class="col-sm-2 form-control-label">
                            <h5>Jam Tutup:</h5>
                        </label>
                        <div class="col-sm-10">
                            {{ form.jam_tutup }}
                        </div>
                    </div>
                    <input type="submit" class="btn btn-primary btn-lg" value="Ubah"/>
                </div>
            </form>

            </p>
        </div>
    </div>
</div>
</div>


{% endblock %}